package atomicstryker.minions.common.entity;

import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.ai.RandomPositionGenerator;
import net.minecraft.util.Vec3;

public class MinionAIWander extends EntityAIBase
{
    private EntityMinion entity;
    private double xPosition;
    private double yPosition;
    private double zPosition;
    private float speed;
    private long nextMoveTime;
    private final long moveTimeIntervals = 10000L;

    public MinionAIWander(EntityMinion minion, float movespeed)
    {
        this.entity = minion;
        this.speed = movespeed;
        nextMoveTime = System.currentTimeMillis();
    }

    /**
     * Returns whether the EntityAIBase should begin execution.
     */
    @Override
    public boolean func_75250_a()
    {
        if (entity.getCurrentTask() != null
        || entity.field_70153_n != null)
        {
            return false;
        }
        else if (nextMoveTime < System.currentTimeMillis())
        {
            Vec3 vec3 = RandomPositionGenerator.func_75463_a(this.entity, 6, 4);

            if (vec3 == null)
            {
                return false;
            }
            else
            {
                this.xPosition = vec3.field_72450_a;
                this.yPosition = vec3.field_72448_b;
                this.zPosition = vec3.field_72449_c;
                nextMoveTime = System.currentTimeMillis() + (long) (moveTimeIntervals * entity.func_70681_au().nextFloat());
                return true;
            }
        }
        return false;
    }

    /**
     * Returns whether an in-progress EntityAIBase should continue executing
     */
    @Override
    public boolean func_75253_b()
    {
        return entity.getCurrentTask() == null && !this.entity.func_70661_as().func_75500_f();
    }

    /**
     * Execute a one shot task or start executing a continuous task
     */
    @Override
    public void func_75249_e()
    {
        this.entity.func_70661_as().func_75492_a(this.xPosition, this.yPosition, this.zPosition, this.speed);
    }
}
